	program Enter

C* Title:	FIDDEL.FOR	V0.1
C* Author:	Shawn A. Clifford
C* Date:	04-MAR-1993
C* Purpose:	Delete a file by its FID.
C* Usage:	FIDDEL {file_id}
C*
C*		file_id   -  File identification in the form:
C*			number, sequence [, revision]
C*
C*		number, sequence, revision  -  unsigned integers (word)
C*
C* Note:	'FIDDEL' must be defined as a foreign command verb.
C*		eg.  FIDDEL:==$disk:[dir]FIDDEL.EXE
C*
C* To Build:	$ SET COM/OBJ FIDDEL_CLD
C*		$ FOR/NODEB/OPT/EXTEND FIDDEL
C*		$ LIN/NODEB/NOTRACE/CONTIG FIDDEL, FIDDEL_CLD


	implicit none

c	include '($namdef)'
c	include '($fabdef)'
c	include '($fibdef)'
c	include '($atrdef)'
c	include '($iodef)'

c
c	Converted all the $EQU statements in the $NAMDEF.MAR and $FABDEF.MAR
c	macros, stored in the SYS$LIBRARY:STARLET.MLB macro library, into
c	FORTRAN PARAMETER statements for symbol definitions.  Just using:
c		include '($fabdef)'
c	would not allow me to use the symbol names the way I needed.
c	The important point is that the FAB$x_ (or NAM$x_) values are OFFSETS
c	into the FAB/NAM blocks for the locations of the FAB/NAM fields.
c	These offsets are BYTE offsets from the top of the block, therefore
c	we need to divide by 2 or 4 when accessing WORD or LONGWORD cells.
c
c	From $NAMDEF, $FABDEF, $ATRDEF, and $IODEF:
c
	PARAMETER	NAM$C_BID	=	2,
	1		NAM$C_BLN	=	96,
	1		NAM$C_MAXRSS	=	255,
	1		NAM$W_FID	=	36,
	1		NAM$W_FID_SEQ	=	38,
	1		NAM$W_FID_RVN	=	40,
	1		NAM$B_RSL	=	3,
	1		NAM$B_ESL	=	11,
	1		NAM$B_BLN	=	1,
	1		NAM$B_BID	=	0,
	1		NAM$B_RSS	=	2,
	1		NAM$B_ESS	=	10,
	1		NAM$L_RSA	=	4,
	1		NAM$L_ESA	=	12

	PARAMETER 	FAB$C_BID	=	3,
	1		FAB$C_BLN	=	80,
	1		FAB$M_NAM	=	16777216,
	1		FAB$M_OFP	=	536870912,
	1		FAB$B_FNS	=	52,
	1		FAB$B_DNS	=	33,
	1		FAB$B_BLN	=	1,
	1		FAB$B_BID	=	0,
	1		FAB$L_FOP	=	4,
	1		FAB$L_NAM	=	40,
	1		FAB$L_FNA	=	44,
	1		FAB$L_DNA	=	48

	PARAMETER	ATR$S_FILE_SPEC	=	512,
	1		ATR$C_FILE_SPEC	=	46

	PARAMETER	IO$_ACCESS	=	50,
	1		IO$M_ACCESS	=	64,
	1		IO$_DEACCESS	=	52

 	PARAMETER	naml_siz = (NAM$C_BLN/4),
	1		namw_siz = (NAM$C_BLN/2),
	1		fabl_siz = (FAB$C_BLN/4),
	1		fabw_siz = (FAB$C_BLN/2)

c     Create an $QIOW argument descriptor
	structure /arg_descr/
	  union
	     MAP
	        integer*2 count
	        integer*2 not_used
	        integer*4 addr
	     END MAP
	     MAP
                integer*4 eol	/0/
	     END MAP
	  end union
	end structure
	record /arg_descr/ fib_descriptor


c     Create an attribute block
	structure /attribute_block/
	  union
	     MAP
	        integer*2 size
	        integer*2 type
	        integer*4 addr
	     END MAP
	     MAP
                integer*4 eol	/0/
	     END MAP
	  end union
	end structure
	record /attribute_block/ attrib


c     Create a short FIB block
	structure /fib_block/
	  union
	     MAP
	        integer*4 acctl
	     END MAP
	     MAP
		integer*2 acctl_overlay
		byte      acctl_overlay_2
		byte      wsize
	    ENDMAP
	  end union
	  union
	     MAP
		integer*2 fid
	     END MAP
	     MAP
		integer*2 fid_num
	     END MAP
	  end union
		integer*2 fid_seq
		integer*2 fid_rvn
	  union
	     MAP
		integer*2 did
	     END MAP
	     MAP
		integer*2 did_num
	     END MAP
	  end union
		integer*2 did_seq
		integer*2 did_rvn
		integer*4 wcc
		integer*2 nmctl
	end structure
	record /fib_block/ fib

c
c	Define the access blocks.  Put the byte definitions after INTEGER*4,
c	and before INTEGER*2 definitions to keep the blocks longword aligned.
c	The access blocks are define for BYTE, WORD, and LONGWORD arrays
c	so that we may access the different FAB/NAM cell locations according
c	to the cell sizes.
c
	integer*4	naml (0:naml_siz-1)
	integer*4	fabl (0:fabl_siz-1)
	byte		fabb (0:FAB$C_BLN-1)	/FAB$C_BLN*0/
	byte		namb (0:NAM$C_BLN-1)	/NAM$C_BLN*0/
	integer*2	nam  (0:namw_siz-1)
	integer*2	fab  (0:fabw_siz-1)

	character*(NAM$C_MAXRSS)  inp_str, esa_str,	! String space
	1	cmdline, res_str, dna_str		/'FILE.ENTERED'/

	character*(ATR$S_FILE_SPEC)	file
	character*(255) backlink
	character*37	prompt/'Name of file entry (w/o wildcards):  '/
	character*5	word_str	! Read number data here, then convert.

	integer*2	fid_num, fid_seq, fid_rvn	! FileID words.
	integer*2	chan, func

c	Various string lengths.
	byte		len, inp_str_len, res_str_len, esa_str_len,
	1		dna_str_len 	/12/

	integer*4	stat, lib$get_input, sys$parse, lib$signal,
	1		sys$erase, ots$cvt_tu_l, sys$search, cli$present,
	1		cli$dcl_parse, cli$get_value, lib$get_foreign,
	1		sys$qiow, sys$assign, pos1, pos2

	external	lib$get_input, sys$parse, lib$signal, sys$exit,
	1		sys$erase, ots$cvt_tu_l, sys$search, cli$present,
	1		cli$dcl_parse, cli$get_value, lib$get_foreign,
	1		fiddel_cld, sys$qiow, sys$assign, sys$dassgn


c
c	Overlay common locations for easy access.
c
	equivalence	(fabb,fab,fabl),	! The FAB block.
	1	(namb,nam,naml),		! The NAM block.
	1	(fid_num, nam(NAM$W_FID/2)),	! The three ...
	1	(fid_seq, nam(NAM$W_FID_SEQ/2)),! ... words in
	1	(fid_rvn, nam(NAM$W_FID_RVN/2)),! ... the FID.
	1	(inp_str_len, fabb(FAB$B_FNS)),	! File name length.
	1	(res_str_len, namb(NAM$B_RSL)),	! Result str length.
	1	(dna_str_len, fabb(FAB$B_DNS)),	! Default str length.
	1	(esa_str_len, namb(NAM$B_ESL))	! Expanded str length.


C-------------------------------------------------

c
c	Setup the FIB and attribute block so that we may lookup the filename
c	already assigned to a given FID.
c
	fib_descriptor.count = sizeof(fib)
	fib_descriptor.addr  = %loc(fib)

	attrib.size = ATR$S_FILE_SPEC
	attrib.type = ATR$C_FILE_SPEC
	attrib.addr = %loc(file)

c
c	Initialize access blocks.
c	Usually taken care of in MACRO by the $NAM and $FAB macros.
c
c	First the NAM block...
c
	namb(NAM$B_BLN) = NAM$C_BLN	! Define the size of the block.
	namb(NAM$B_BID) = NAM$C_BID	! Tell RMS that it is a NAM block.
	namb(NAM$B_RSS) = NAM$C_MAXRSS	! Tell how big result can be.
	namb(NAM$B_ESS) = NAM$C_MAXRSS	! Tell how big expanded str may be.
	naml(NAM$L_RSA/4) = %loc(res_str)	! Point to result string.
	naml(NAM$L_ESA/4) = %loc(esa_str)	! Point to filespec to enter.
c
c	... and now the FAB block.
c
	fabb(FAB$B_BLN) = FAB$C_BLN	! Define size.
	fabb(FAB$B_BID) = FAB$C_BID	! This is a FAB block.
c		Let RMS know to use NAM block and DNA
	fabl(FAB$L_FOP/4) = FAB$M_NAM + FAB$M_OFP
	fabl(FAB$L_NAM/4) = %loc(nam)	! Chain up the NAM block.
	fabl(FAB$L_FNA/4) = %loc(inp_str)	! Point to input filespec.
	fabl(FAB$L_DNA/4) = %loc(dna_str)	! Default file info.

c
c	Use the CLI to get the filename and FID.
c	The CLI will prompt for the FID if it is missing, and will return
c	error messages on its own (hence sys$exit(1) below).
c
	call lib$get_foreign (cmdline,,len)
	stat=cli$dcl_parse('FIDDEL '//cmdline(:len), fiddel_cld,
	1	lib$get_input,,)
	if (iand(stat, '00000001'x).ne.1) call sys$exit(%val(1))

c
c	Parse the input so that we may get the expanded string length.
c
	stat = sys$parse(fab,,)
	if (IAND(stat,'00000001'x).ne.1) call sys$exit(%val(stat))

c
c	Get the FID.  You don't usually use the relative volume number.
c	Note:  fid_xxx map directly into their NAM fields.  We set these
c	AFTER calling sys$parse because sys$parse zeroes these fields out.
c	Values are read into a character buffer, then converted to
c	unsigned words, ignoring tabs and blanks.
c
c		File number
c
	if (cli$get_value('IDENTIFIER', word_str, len))
	1   call ots$cvt_tu_l(word_str, fid_num, %val(2), %val('11'x))
c		File sequence
	if (cli$get_value('IDENTIFIER', word_str, len))
	1	call ots$cvt_tu_l(word_str, fid_seq, %val(2), %val('11'x))
c		File revision
	if (cli$get_value('IDENTIFIER', word_str, len))
	1	call ots$cvt_tu_l(word_str, fid_rvn, %val(2), %val('11'x))

c
c	Get the backlink on the file.
c
	fib.fid_num = fid_num
	fib.fid_seq = fid_seq
	fib.fid_rvn = fid_rvn

	stat = sys$assign('sys$disk', %ref(chan),,)
	if (IAND(stat,'00000001'x).ne.1) call sys$exit(%val(stat))

	func = IO$_ACCESS + IO$M_ACCESS
	stat = sys$qiow(,%val(chan),%val(func),,,,fib_descriptor,,,,
	1	%ref(attrib),)

	func = IO$_DEACCESS
	stat = sys$qiow(,%val(chan),%val(func),,,,fib_descriptor,,,,
	1	%ref(attrib),)
	if (IAND(stat,'00000001'x).ne.1) call sys$exit(%val(stat))

        call sys$dassgn(%val(chan))

c
c	   File spec is returned as a counted string w/ null padding.  Skip
c	   over the count word, and cut out the backlink and the file name.
c
	pos1 = index(file, '[')
	pos2 = index(file, ']')
	backlink = file(pos1:pos2)
	pos1 = pos2+1
	pos2 = index(file, ';') -1
	file = file(pos1:pos2)
	pos2 = pos2-pos1+1
	pos1 = index(backlink, ']')

	print *
	print *, 'Backlink directory:   ', backlink(:pos1)
	print *, 'Deleted file name :   ', file(:pos2)

c
c	Delete the file.
c
	stat = sys$erase(fab,,)
	if (IAND(stat,'00000001'x).ne.1) call sys$exit(%val(stat))

	end
